]> git.saurik.com Git - cydia.git/blobdiff - sysroot.sh
Provide more guarantees against merge catastrophe.
[cydia.git] / sysroot.sh
index 77ad994bce7e63368d555130b18aabc771f5dca2..286070701a3d2ef4592282e71ce26f002b4c02f6 100755 (executable)
@@ -5,10 +5,25 @@ if [[ ${BASH_VERSION} != 4* ]]; then
     exit 1
 fi
 
+set -o pipefail
+set -e
+
 shopt -s extglob
 shopt -s nullglob
 
-PATH=/Library/Cydia/bin:$PATH
+for command in unlzma wget; do
+    if ! which "${command}" &>/dev/null; then
+        echo "Cannot run \`${command}\`. Please read compiling.txt." 1>&2
+        exit 1
+    fi
+done
+
+if tar --help | grep bsdtar &>/dev/null; then
+    echo "Running \`tar\` is bsdtar :(. Please read compiling.txt." 1>&2
+    exit 1
+fi
+
+xcode=$(xcodebuild -sdk macosx -version Path)
 
 rm -rf sysroot
 mkdir sysroot
@@ -19,48 +34,81 @@ distribution=tangelo
 component=main
 architecture=iphoneos-arm
 
-wget -qO- "${repository}dists/${distribution}/${component}/binary-${architecture}/Packages.bz2" | bzcat | {
-    regex='^([^ \t]*): *(.*)'
-    declare -A fields
-
-    while IFS= read -r line; do
-        if [[ ${line} == '' ]]; then
-            package=${fields[package]}
-            if [[ ${package} == *(apr|apr-lib|apt7|apt7-lib|coreutils|mobilesubstrate|pcre) ]]; then
-                filename=${fields[filename]}
-                wget -O "${package}.deb" "${repository}${filename}"
-                dpkg-deb -x "${package}.deb" .
-            fi
+declare -A dpkgz
+dpkgz[gz]=gunzip
+dpkgz[lzma]=unlzma
+
+function extract() {
+    package=$1
+    url=$2
 
-            unset fields
-            declare -A fields
-        elif [[ ${line} =~ ${regex} ]]; then
-            name=${BASH_REMATCH[1],,}
-            value=${BASH_REMATCH[2]}
-            fields[${name}]=${value}
+    wget -O "${package}.deb" "${url}"
+    for z in lzma gz; do
+        compressed=data.tar.${z}
+
+        if ar -x "${package}.deb" "${compressed}" 2>/dev/null; then
+            ${dpkgz[${z}]} "${compressed}"
+            break
         fi
     done
-}
 
-rm -f *.deb
-
-if substrate=$(readlink usr/include/substrate.h); then
-    if [[ ${substrate} == /* ]]; then
-        ln -sf "../..${substrate}" usr/include/substrate.h
+    if ! [[ -e data.tar ]]; then
+        echo "unable to extract package" 1>&2
+        exit 1
     fi
+
+    ls -la data.tar
+    tar -xf ./data.tar
+    rm -f data.tar
+}
+
+declare -A urls
+
+urls[apt7]=http://apt.saurik.com/debs/apt7_0.7.25.3-7_iphoneos-arm.deb
+urls[apt7-lib]=http://apt.saurik.com/debs/apt7-lib_0.7.25.3-12_iphoneos-arm.deb
+urls[coreutils]=http://apt.saurik.com/debs/coreutils_7.4-11_iphoneos-arm.deb
+
+if [[ 0 ]]; then
+    wget -qO- "${repository}dists/${distribution}/${component}/binary-${architecture}/Packages.bz2" | bzcat | {
+        regex='^([^ \t]*): *(.*)'
+        declare -A fields
+
+        while IFS= read -r line; do
+            if [[ ${line} == '' ]]; then
+                package=${fields[package]}
+                if [[ -n ${urls[${package}]} ]]; then
+                    filename=${fields[filename]}
+                    urls[${package}]=${repository}${filename}
+                fi
+
+                unset fields
+                declare -A fields
+            elif [[ ${line} =~ ${regex} ]]; then
+                name=${BASH_REMATCH[1],,}
+                value=${BASH_REMATCH[2]}
+                fields[${name}]=${value}
+            fi
+        done
+    }
 fi
 
+for package in "${!urls[@]}"; do
+    extract "${package}" "${urls[${package}]}"
+done
+
+rm -f *.deb
+
 mkdir -p usr/include
 cd usr/include
 
 mkdir CoreFoundation
 wget -O CoreFoundation/CFBundlePriv.h "http://www.opensource.apple.com/source/CF/CF-550/CFBundlePriv.h?txt"
-wget -O CoreFoundation/CFPriv.h "http://www.opensource.apple.com/source/CF/CF-550/CFPriv.h?txt"
 wget -O CoreFoundation/CFUniChar.h "http://www.opensource.apple.com/source/CF/CF-550/CFUniChar.h?txt"
 
 if true; then
     mkdir -p WebCore
     wget -O WebCore/WebCoreThread.h 'http://www.opensource.apple.com/source/WebCore/WebCore-658.28/wak/WebCoreThread.h?txt'
+    wget -O WebCore/WebEvent.h 'http://www.opensource.apple.com/source/WebCore/WebCore-658.28/platform/iphone/WebEvent.h?txt'
 else
     wget -O WebCore.tgz http://www.opensource.apple.com/tarballs/WebCore/WebCore-658.28.tar.gz
     tar -zx --transform 's@^[^/]*/@WebCore.d/@' -f WebCore.tgz
@@ -85,15 +133,15 @@ else
     ')
 fi
 
-for framework in ApplicationServices CoreServices IOKit IOSurface JavaScriptCore QuartzCore WebKit; do
-    ln -s /System/Library/Frameworks/"${framework}".framework/Headers "${framework}"
+for framework in ApplicationServices CoreServices IOKit IOSurface JavaScriptCore WebKit; do
+    ln -s "${xcode}"/System/Library/Frameworks/"${framework}".framework/Headers "${framework}"
 done
 
 for framework in /System/Library/Frameworks/CoreServices.framework/Frameworks/*.framework; do
     name=${framework}
     name=${name%.framework}
     name=${name##*/}
-    ln -s "${framework}/Headers" "${name}"
+    ln -s "${xcode}/${framework}/Headers" "${name}"
 done
 
 mkdir -p Cocoa